# A||GO API-Client python library
We provide here a simple API client for [A||GO](https://allgo18.inria.fr) written in Python.

[![pipeline status](https://gitlab.inria.fr/allgo/api-clients/python_client/badges/client_api/pipeline.svg)](https://gitlab.inria.fr/allgo/api-clients/python_client/commits/client_api)
python 2.7: [![coverage report 2.7](https://gitlab.inria.fr/allgo/api-clients/python_client/badges/client_api/coverage.svg?job=tests:2.7)](https://gitlab.inria.fr/allgo/api-clients/python_client/commits/client_api?job=tests:2.7)
python 3.7: [![coverage report 3.7](https://gitlab.inria.fr/allgo/api-clients/python_client/badges/client_api/coverage.svg?job=tests:3.7)](https://gitlab.inria.fr/allgo/api-clients/python_client/commits/client_api?job=tests:3.7)

## Description
AllGo is a SaaS (Software as a Service) platform provided by Inria. It may be seen as a virtual showroom of technologies developed by research teams.
First follow https://allgo18.inria.fr/accounts/login/ to create an account on AllGo (anyone may create such an account). Once your account creation is confirmed, please connect to https://allgo18.inria.fr to obtain your private token, which will allow you to use the AllGo REST API. You will need this token later (cf. §3 below).

## Installing
```
  # to use it
  pip3 install allgo

  # to develop
  pip3 install -r requirements.txt allgo
```
Note: to be able to generate the documentation you need to install [pandoc](http://pandoc.org/installing.html).

### Documentation

The reference documentation is available on this website : https://allgo.gitlabpages.inria.fr/api-clients/python_client

You may want to rebuild it :
``` cd doc && make html```
This will create a `_build` directory with all the html files.

## Content
```
├── allgo ............. The python code
├── doc ............... Documentations
├── MANIFEST.in ....... File needed to describe the package
├── notebooks ......... All the sample notebooks
├── pytest.ini ........ conf file for pytest
├── README.md ......... This file !
├── requirements.txt .. List of requirement packages
├── setup.py .......... Package settings
└── tests ............. Directory of tests
```

## Usage

### Create an Allgo object
```
  client = allgo.Client('ndsafir', token="ead123baaef55412")
```

NB: token is optional if you already provide it with an env variable ALLGO_TOKEN or create a file ~/.allgo_token (without breakline)

### Submit a job
```
  files  = ['tmp.png']
  params = '-nopeaks 1 -2dt false -noise 0 -p 1 -bits 8 -iter 5 -adapt 0'
  client.run_job(files=files, params=params)
```

run_job is blocking.

### More explanations ?

Check the documention (doc dir) or the [demo notebook](notebooks/demo_short.ipynb)

## Example :

cf `notebooks` dir.
Also check this one
[https://gitlab.inria.fr/allgo/notebooks/ndsafir](https://gitlab.inria.fr/allgo/notebooks/ndsafir)

